Index: tmp/org.txm.utils/src/org/txm/utils/Diff.java
===================================================================
--- tmp/org.txm.utils/src/org/txm/utils/Diff.java	(revision 2401)
+++ tmp/org.txm.utils/src/org/txm/utils/Diff.java	(revision 2402)
@@ -30,937 +30,964 @@
 import java.util.ArrayList;
 import java.util.Hashtable;
 
-/** A class to compare vectors of objects.  The result of comparison
-    is a list of <code>change</code> objects which form an
-    edit script.  The objects compared are traditionally lines
-    of text from two files.  Comparison options such as "ignore
-    whitespace" are implemented by modifying the <code>equals</code>
-    and <code>hashcode</code> methods for the objects compared.
-<p>
-   The basic algorithm is described in: </br>
-   "An O(ND) Difference Algorithm and its Variations", Eugene Myers,
-   Algorithmica Vol. 1 No. 2, 1986, p 251.  
-<p>
-   This class outputs different results from GNU diff 1.15 on some
-   inputs.  Our results are actually better (smaller change list, smaller
-   total size of changes), but it would be nice to know why.  Perhaps
-   there is a memory overwrite bug in GNU diff 1.15.
-
-  @author Stuart D. Gathman, translated from GNU diff 1.15
-    Copyright (C) 2000  Business Management Systems, Inc.
-<p>
-    This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation; either version 1, or (at your option)
-    any later version.
-<p>
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
-<p>
-    You should have received a copy of the <a href=COPYING.txt>
-    GNU General Public License</a>
-    along with this program; if not, write to the Free Software
-    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
+/**
+ * A class to compare vectors of objects. The result of comparison is a list of
+ * <code>change</code> objects which form an edit script. The objects compared
+ * are traditionally lines of text from two files. Comparison options such as
+ * "ignore whitespace" are implemented by modifying the <code>equals</code> and
+ * <code>hashcode</code> methods for the objects compared.
+ * <p>
+ * The basic algorithm is described in: </br>
+ * "An O(ND) Difference Algorithm and its Variations", Eugene Myers,
+ * Algorithmica Vol. 1 No. 2, 1986, p 251.
+ * <p>
+ * This class outputs different results from GNU diff 1.15 on some inputs. Our
+ * results are actually better (smaller change list, smaller total size of
+ * changes), but it would be nice to know why. Perhaps there is a memory
+ * overwrite bug in GNU diff 1.15.
+ * 
+ * @author Stuart D. Gathman, translated from GNU diff 1.15 Copyright (C) 2000
+ *         Business Management Systems, Inc.
+ *         <p>
+ *         This program is free software; you can redistribute it and/or modify
+ *         it under the terms of the GNU General Public License as published by
+ *         the Free Software Foundation; either version 1, or (at your option)
+ *         any later version.
+ *         <p>
+ *         This program is distributed in the hope that it will be useful, but
+ *         WITHOUT ANY WARRANTY; without even the implied warranty of
+ *         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ *         General Public License for more details.
+ *         <p>
+ *         You should have received a copy of the <a href=COPYING.txt> GNU
+ *         General Public License</a> along with this program; if not, write to
+ *         the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
+ *         02139, USA.
+ * 
  */
 
 public class Diff {
 
-  /** Prepare to find differences between two arrays.  Each element of
-      the arrays is translated to an "equivalence number" based on
-      the result of <code>equals</code>.  The original Object arrays
-      are no longer needed for computing the differences.  They will
-      be needed again later to print the results of the comparison as
-      an edit script, if desired.
-   */
-  public Diff(Object[] a,Object[] b) {
-    Hashtable h = new Hashtable(a.length + b.length);
-    filevec[0] = new file_data(a,h);
-    filevec[1] = new file_data(b,h);
-  }
+	/**
+	 * Prepare to find differences between two arrays. Each element of the arrays is
+	 * translated to an "equivalence number" based on the result of
+	 * <code>equals</code>. The original Object arrays are no longer needed for
+	 * computing the differences. They will be needed again later to print the
+	 * results of the comparison as an edit script, if desired.
+	 */
+	public Diff(Object[] a, Object[] b) {
+		Hashtable h = new Hashtable(a.length + b.length);
+		filevec[0] = new file_data(a, h);
+		filevec[1] = new file_data(b, h);
+	}
 
-  /** 1 more than the maximum equivalence value used for this or its
-     sibling file. */
-  private int equiv_max = 1;
+	/**
+	 * 1 more than the maximum equivalence value used for this or its sibling file.
+	 */
+	private int equiv_max = 1;
 
-  /** When set to true, the comparison uses a heuristic to speed it up.
-    With this heuristic, for files with a constant small density
-    of changes, the algorithm is linear in the file size.  */
-  public boolean heuristic = false;
+	/**
+	 * When set to true, the comparison uses a heuristic to speed it up. With this
+	 * heuristic, for files with a constant small density of changes, the algorithm
+	 * is linear in the file size.
+	 */
+	public boolean heuristic = false;
 
-  /** When set to true, the algorithm returns a guarranteed minimal
-      set of changes.  This makes things slower, sometimes much slower. */
-  public boolean no_discards = false;
+	/**
+	 * When set to true, the algorithm returns a guarranteed minimal set of changes.
+	 * This makes things slower, sometimes much slower.
+	 */
+	public boolean no_discards = false;
 
-  private int[] xvec, yvec;	/* Vectors being compared. */
-  private int[] fdiag;		/* Vector, indexed by diagonal, containing
-				   the X coordinate of the point furthest
-				   along the given diagonal in the forward
-				   search of the edit matrix. */
-  private int[] bdiag;		/* Vector, indexed by diagonal, containing
-				   the X coordinate of the point furthest
-				   along the given diagonal in the backward
-				   search of the edit matrix. */
-  private int fdiagoff, bdiagoff;
-  private final file_data[] filevec = new file_data[2];
-  private int cost;
-  /** Snakes bigger than this are considered "big". */
-  private static final int SNAKE_LIMIT = 20;
+	private int[] xvec, yvec; /* Vectors being compared. */
+	private int[] fdiag; /*
+							 * Vector, indexed by diagonal, containing the X coordinate of the point
+							 * furthest along the given diagonal in the forward search of the edit matrix.
+							 */
+	private int[] bdiag; /*
+							 * Vector, indexed by diagonal, containing the X coordinate of the point
+							 * furthest along the given diagonal in the backward search of the edit matrix.
+							 */
+	private int fdiagoff, bdiagoff;
+	private final file_data[] filevec = new file_data[2];
+	private int cost;
+	/** Snakes bigger than this are considered "big". */
+	private static final int SNAKE_LIMIT = 20;
 
-  /** Find the midpoint of the shortest edit script for a specified
-     portion of the two files.
+	/**
+	 * Find the midpoint of the shortest edit script for a specified portion of the
+	 * two files.
+	 * 
+	 * We scan from the beginnings of the files, and simultaneously from the ends,
+	 * doing a breadth-first search through the space of edit-sequence. When the two
+	 * searches meet, we have found the midpoint of the shortest edit sequence.
+	 * 
+	 * The value returned is the number of the diagonal on which the midpoint lies.
+	 * The diagonal number equals the number of inserted lines minus the number of
+	 * deleted lines (counting only lines before the midpoint). The edit cost is
+	 * stored into COST; this is the total number of lines inserted or deleted
+	 * (counting only lines before the midpoint).
+	 * 
+	 * This function assumes that the first lines of the specified portions of the
+	 * two files do not match, and likewise that the last lines do not match. The
+	 * caller must trim matching lines from the beginning and end of the portions it
+	 * is going to specify.
+	 * 
+	 * Note that if we return the "wrong" diagonal value, or if the value of bdiag
+	 * at that diagonal is "wrong", the worst this can do is cause suboptimal diff
+	 * output. It cannot cause incorrect diff output.
+	 */
 
-     We scan from the beginnings of the files, and simultaneously from the ends,
-     doing a breadth-first search through the space of edit-sequence.
-     When the two searches meet, we have found the midpoint of the shortest
-     edit sequence.
+	private int diag(int xoff, int xlim, int yoff, int ylim) {
+		final int[] fd = fdiag; // Give the compiler a chance.
+		final int[] bd = bdiag; // Additional help for the compiler.
+		final int[] xv = xvec; // Still more help for the compiler.
+		final int[] yv = yvec; // And more and more . . .
+		final int dmin = xoff - ylim; // Minimum valid diagonal.
+		final int dmax = xlim - yoff; // Maximum valid diagonal.
+		final int fmid = xoff - yoff; // Center diagonal of top-down search.
+		final int bmid = xlim - ylim; // Center diagonal of bottom-up search.
+		int fmin = fmid, fmax = fmid; // Limits of top-down search.
+		int bmin = bmid, bmax = bmid; // Limits of bottom-up search.
+		/*
+		 * True if southeast corner is on an odd diagonal with respect to the northwest.
+		 */
+		final boolean odd = (fmid - bmid & 1) != 0;
 
-     The value returned is the number of the diagonal on which the midpoint lies.
-     The diagonal number equals the number of inserted lines minus the number
-     of deleted lines (counting only lines before the midpoint).
-     The edit cost is stored into COST; this is the total number of
-     lines inserted or deleted (counting only lines before the midpoint).
+		fd[fdiagoff + fmid] = xoff;
+		bd[bdiagoff + bmid] = xlim;
 
-     This function assumes that the first lines of the specified portions
-     of the two files do not match, and likewise that the last lines do not
-     match.  The caller must trim matching lines from the beginning and end
-     of the portions it is going to specify.
+		for (int c = 1;; ++c) {
+			int d; /* Active diagonal. */
+			boolean big_snake = false;
 
-     Note that if we return the "wrong" diagonal value, or if
-     the value of bdiag at that diagonal is "wrong",
-     the worst this can do is cause suboptimal diff output.
-     It cannot cause incorrect diff output.  */
+			/* Extend the top-down search by an edit step in each diagonal. */
+			if (fmin > dmin)
+				fd[fdiagoff + --fmin - 1] = -1;
+			else
+				++fmin;
+			if (fmax < dmax)
+				fd[fdiagoff + ++fmax + 1] = -1;
+			else
+				--fmax;
+			for (d = fmax; d >= fmin; d -= 2) {
+				int x, y, oldx, tlo = fd[fdiagoff + d - 1], thi = fd[fdiagoff + d + 1];
 
-  private int diag (int xoff, int xlim, int yoff, int ylim) {
-    final int[] fd = fdiag;	// Give the compiler a chance.
-    final int[] bd = bdiag;	// Additional help for the compiler.
-    final int[] xv = xvec;		// Still more help for the compiler.
-    final int[] yv = yvec;		// And more and more . . .
-    final int dmin = xoff - ylim;	// Minimum valid diagonal.
-    final int dmax = xlim - yoff;	// Maximum valid diagonal.
-    final int fmid = xoff - yoff;	// Center diagonal of top-down search.
-    final int bmid = xlim - ylim;	// Center diagonal of bottom-up search.
-    int fmin = fmid, fmax = fmid;	// Limits of top-down search.
-    int bmin = bmid, bmax = bmid;	// Limits of bottom-up search.
-    /* True if southeast corner is on an odd
-				     diagonal with respect to the northwest. */
-    final boolean odd = (fmid - bmid & 1) != 0;	
+				if (tlo >= thi)
+					x = tlo + 1;
+				else
+					x = thi;
+				oldx = x;
+				y = x - d;
+				while (x < xlim && y < ylim && xv[x] == yv[y]) {
+					++x;
+					++y;
+				}
+				if (x - oldx > SNAKE_LIMIT)
+					big_snake = true;
+				fd[fdiagoff + d] = x;
+				if (odd && bmin <= d && d <= bmax && bd[bdiagoff + d] <= fd[fdiagoff + d]) {
+					cost = 2 * c - 1;
+					return d;
+				}
+			}
 
-    fd[fdiagoff + fmid] = xoff;
-    bd[bdiagoff + bmid] = xlim;
+			/* Similar extend the bottom-up search. */
+			if (bmin > dmin)
+				bd[bdiagoff + --bmin - 1] = Integer.MAX_VALUE;
+			else
+				++bmin;
+			if (bmax < dmax)
+				bd[bdiagoff + ++bmax + 1] = Integer.MAX_VALUE;
+			else
+				--bmax;
+			for (d = bmax; d >= bmin; d -= 2) {
+				int x, y, oldx, tlo = bd[bdiagoff + d - 1], thi = bd[bdiagoff + d + 1];
 
-    for (int c = 1;; ++c)
-      {
-	int d;			/* Active diagonal. */
-	boolean big_snake = false;
+				if (tlo < thi)
+					x = tlo;
+				else
+					x = thi - 1;
+				oldx = x;
+				y = x - d;
+				while (x > xoff && y > yoff && xv[x - 1] == yv[y - 1]) {
+					--x;
+					--y;
+				}
+				if (oldx - x > SNAKE_LIMIT)
+					big_snake = true;
+				bd[bdiagoff + d] = x;
+				if (!odd && fmin <= d && d <= fmax && bd[bdiagoff + d] <= fd[fdiagoff + d]) {
+					cost = 2 * c;
+					return d;
+				}
+			}
 
-	/* Extend the top-down search by an edit step in each diagonal. */
-	if (fmin > dmin)
-	  fd[fdiagoff + --fmin - 1] = -1;
-	else
-	  ++fmin;
-	if (fmax < dmax)
-	  fd[fdiagoff + ++fmax + 1] = -1;
-	else
-	  --fmax;
-	for (d = fmax; d >= fmin; d -= 2)
-	  {
-	    int x, y, oldx, tlo = fd[fdiagoff + d - 1], thi = fd[fdiagoff + d + 1];
+			/*
+			 * Heuristic: check occasionally for a diagonal that has made lots of progress
+			 * compared with the edit distance. If we have any such, find the one that has
+			 * made the most progress and return it as if it had succeeded.
+			 * 
+			 * With this heuristic, for files with a constant small density of changes, the
+			 * algorithm is linear in the file size.
+			 */
 
-	    if (tlo >= thi)
-	      x = tlo + 1;
-	    else
-	      x = thi;
-	    oldx = x;
-	    y = x - d;
-	    while (x < xlim && y < ylim && xv[x] == yv[y]) {
-	      ++x; ++y;
-	    }
-	    if (x - oldx > SNAKE_LIMIT)
-	      big_snake = true;
-	    fd[fdiagoff + d] = x;
-	    if (odd && bmin <= d && d <= bmax && bd[bdiagoff + d] <= fd[fdiagoff + d])
-	      {
-		cost = 2 * c - 1;
-		return d;
-	      }
-	  }
+			if (c > 200 && big_snake && heuristic) {
+				int best = 0;
+				int bestpos = -1;
 
-	/* Similar extend the bottom-up search. */
-	if (bmin > dmin)
-	  bd[bdiagoff + --bmin - 1] = Integer.MAX_VALUE;
-	else
-	  ++bmin;
-	if (bmax < dmax)
-	  bd[bdiagoff + ++bmax + 1] = Integer.MAX_VALUE;
-	else
-	  --bmax;
-	for (d = bmax; d >= bmin; d -= 2)
-	  {
-	    int x, y, oldx, tlo = bd[bdiagoff + d - 1], thi = bd[bdiagoff + d + 1];
+				for (d = fmax; d >= fmin; d -= 2) {
+					int dd = d - fmid;
+					int x = fd[fdiagoff + d];
+					int y = x - d;
+					int v = (x - xoff) * 2 - dd;
+					if (v > 12 * (c + (dd < 0 ? -dd : dd))) {
+						if (v > best && xoff + SNAKE_LIMIT <= x && x < xlim && yoff + SNAKE_LIMIT <= y && y < ylim) {
+							/*
+							 * We have a good enough best diagonal; now insist that it end with a
+							 * significant snake.
+							 */
+							int k;
 
-	    if (tlo < thi)
-	      x = tlo;
-	    else
-	      x = thi - 1;
-	    oldx = x;
-	    y = x - d;
-	    while (x > xoff && y > yoff && xv[x - 1] == yv[y - 1]) {
-	      --x; --y;
-	    }
-	    if (oldx - x > SNAKE_LIMIT)
-	      big_snake = true;
-	    bd[bdiagoff + d] = x;
-	    if (!odd && fmin <= d && d <= fmax && bd[bdiagoff + d] <= fd[fdiagoff + d])
-	      {
-		cost = 2 * c;
-		return d;
-	      }
-	  }
+							for (k = 1; xvec[x - k] == yvec[y - k]; k++)
+								if (k == SNAKE_LIMIT) {
+									best = v;
+									bestpos = d;
+									break;
+								}
+						}
+					}
+				}
+				if (best > 0) {
+					cost = 2 * c - 1;
+					return bestpos;
+				}
 
-	/* Heuristic: check occasionally for a diagonal that has made
-	   lots of progress compared with the edit distance.
-	   If we have any such, find the one that has made the most
-	   progress and return it as if it had succeeded.
+				best = 0;
+				for (d = bmax; d >= bmin; d -= 2) {
+					int dd = d - bmid;
+					int x = bd[bdiagoff + d];
+					int y = x - d;
+					int v = (xlim - x) * 2 + dd;
+					if (v > 12 * (c + (dd < 0 ? -dd : dd))) {
+						if (v > best && xoff < x && x <= xlim - SNAKE_LIMIT && yoff < y && y <= ylim - SNAKE_LIMIT) {
+							/*
+							 * We have a good enough best diagonal; now insist that it end with a
+							 * significant snake.
+							 */
+							int k;
 
-	   With this heuristic, for files with a constant small density
-	   of changes, the algorithm is linear in the file size.  */
+							for (k = 0; xvec[x + k] == yvec[y + k]; k++)
+								if (k == SNAKE_LIMIT) {
+									best = v;
+									bestpos = d;
+									break;
+								}
+						}
+					}
+				}
+				if (best > 0) {
+					cost = 2 * c - 1;
+					return bestpos;
+				}
+			}
+		}
+	}
 
-	if (c > 200 && big_snake && heuristic)
-	  {
-	    int best = 0;
-	    int bestpos = -1;
+	/**
+	 * Compare in detail contiguous subsequences of the two files which are known,
+	 * as a whole, to match each other.
+	 * 
+	 * The results are recorded in the vectors filevec[N].changed_flag, by storing a
+	 * 1 in the element for each line that is an insertion or deletion.
+	 * 
+	 * The subsequence of file 0 is [XOFF, XLIM) and likewise for file 1.
+	 * 
+	 * Note that XLIM, YLIM are exclusive bounds. All line numbers are origin-0 and
+	 * discarded lines are not counted.
+	 */
 
-	    for (d = fmax; d >= fmin; d -= 2)
-	      {
-		int dd = d - fmid;
-		int x = fd[fdiagoff + d];
-		int y = x - d;
-		int v = (x - xoff) * 2 - dd;
-		if (v > 12 * (c + (dd < 0 ? -dd : dd)))
-		  {
-		    if (v > best
-		        && xoff + SNAKE_LIMIT <= x && x < xlim
-			&& yoff + SNAKE_LIMIT <= y && y < ylim)
-		      {
-			/* We have a good enough best diagonal;
-			   now insist that it end with a significant snake.  */
-			int k;
+	private void compareseq(int xoff, int xlim, int yoff, int ylim) {
+		/* Slide down the bottom initial diagonal. */
+		while (xoff < xlim && yoff < ylim && xvec[xoff] == yvec[yoff]) {
+			++xoff;
+			++yoff;
+		}
+		/* Slide up the top initial diagonal. */
+		while (xlim > xoff && ylim > yoff && xvec[xlim - 1] == yvec[ylim - 1]) {
+			--xlim;
+			--ylim;
+		}
 
-			for (k = 1; xvec[x - k] == yvec[y - k]; k++)
-			  if (k == SNAKE_LIMIT)
-			    {
-			      best = v;
-			      bestpos = d;
-			      break;
-			    }
-		      }
-		  }
-	      }
-	    if (best > 0)
-	      {
-		cost = 2 * c - 1;
-		return bestpos;
-	      }
+		/* Handle simple cases. */
+		if (xoff == xlim)
+			while (yoff < ylim)
+				filevec[1].changed_flag[1 + filevec[1].realindexes[yoff++]] = true;
+		else if (yoff == ylim)
+			while (xoff < xlim)
+				filevec[0].changed_flag[1 + filevec[0].realindexes[xoff++]] = true;
+		else {
+			/* Find a point of correspondence in the middle of the files. */
 
-	    best = 0;
-	    for (d = bmax; d >= bmin; d -= 2)
-	      {
-		int dd = d - bmid;
-		int x = bd[bdiagoff + d];
-		int y = x - d;
-		int v = (xlim - x) * 2 + dd;
-		if (v > 12 * (c + (dd < 0 ? -dd : dd)))
-		  {
-		    if (v > best
-		        && xoff < x && x <= xlim - SNAKE_LIMIT
-			&& yoff < y && y <= ylim - SNAKE_LIMIT)
-		      {
-			/* We have a good enough best diagonal;
-			   now insist that it end with a significant snake.  */
-			int k;
+			int d = diag(xoff, xlim, yoff, ylim);
+			int c = cost;
+			int f = fdiag[fdiagoff + d];
+			int b = bdiag[bdiagoff + d];
 
-			for (k = 0; xvec[x + k] == yvec[y + k]; k++)
-			  if (k == SNAKE_LIMIT)
-			    {
-			      best = v;
-			      bestpos = d;
-			      break;
-			    }
-		      }
-		  }
-	      }
-	    if (best > 0)
-	      {
-		cost = 2 * c - 1;
-		return bestpos;
-	      }
-	  }
-      }
-  }
+			if (c == 1) {
+				/*
+				 * This should be impossible, because it implies that one of the two
+				 * subsequences is empty, and that case was handled above without calling
+				 * `diag'. Let's verify that this is true.
+				 */
+				throw new IllegalArgumentException("Empty subsequence"); //$NON-NLS-1$
+			} else {
+				/* Use that point to split this problem into two subproblems. */
+				compareseq(xoff, b, yoff, b - d);
+				/*
+				 * This used to use f instead of b, but that is incorrect! It is not necessarily
+				 * the case that diagonal d has a snake from b to f.
+				 */
+				compareseq(b, xlim, b - d, ylim);
+			}
+		}
+	}
 
-  /** Compare in detail contiguous subsequences of the two files
-     which are known, as a whole, to match each other.
+	/**
+	 * Discard lines from one file that have no matches in the other file.
+	 */
 
-     The results are recorded in the vectors filevec[N].changed_flag, by
-     storing a 1 in the element for each line that is an insertion or deletion.
+	private void discard_confusing_lines() {
+		filevec[0].discard_confusing_lines(filevec[1]);
+		filevec[1].discard_confusing_lines(filevec[0]);
+	}
 
-     The subsequence of file 0 is [XOFF, XLIM) and likewise for file 1.
+	private boolean inhibit = false;
 
-     Note that XLIM, YLIM are exclusive bounds.
-     All line numbers are origin-0 and discarded lines are not counted.  */
+	/**
+	 * Adjust inserts/deletes of blank lines to join changes as much as possible.
+	 */
 
-  private void compareseq (int xoff, int xlim, int yoff, int ylim) {
-    /* Slide down the bottom initial diagonal. */
-    while (xoff < xlim && yoff < ylim && xvec[xoff] == yvec[yoff]) {
-      ++xoff; ++yoff;
-    }
-    /* Slide up the top initial diagonal. */
-    while (xlim > xoff && ylim > yoff && xvec[xlim - 1] == yvec[ylim - 1]) {
-      --xlim; --ylim;
-    }
-    
-    /* Handle simple cases. */
-    if (xoff == xlim)
-      while (yoff < ylim)
-	filevec[1].changed_flag[1+filevec[1].realindexes[yoff++]] = true;
-    else if (yoff == ylim)
-      while (xoff < xlim)
-	filevec[0].changed_flag[1+filevec[0].realindexes[xoff++]] = true;
-    else
-      {
-	/* Find a point of correspondence in the middle of the files.  */
+	private void shift_boundaries() {
+		if (inhibit)
+			return;
+		filevec[0].shift_boundaries(filevec[1]);
+		filevec[1].shift_boundaries(filevec[0]);
+	}
 
-	int d = diag (xoff, xlim, yoff, ylim);
-	int c = cost;
-	int f = fdiag[fdiagoff + d];
-	int b = bdiag[bdiagoff + d];
+	public interface ScriptBuilder {
+		/**
+		 * Scan the tables of which lines are inserted and deleted, producing an edit
+		 * script.
+		 * 
+		 * @param changed0
+		 *            true for lines in first file which do not match 2nd
+		 * @param len0
+		 *            number of lines in first file
+		 * @param changed1
+		 *            true for lines in 2nd file which do not match 1st
+		 * @param len1
+		 *            number of lines in 2nd file
+		 * @return a linked list of changes - or null
+		 */
+		public change build_script(boolean[] changed0, int len0, boolean[] changed1, int len1);
+	}
 
-	if (c == 1)
-	  {
-	    /* This should be impossible, because it implies that
-	       one of the two subsequences is empty,
-	       and that case was handled above without calling `diag'.
-	       Let's verify that this is true.  */
-	    throw new IllegalArgumentException("Empty subsequence"); //$NON-NLS-1$
-	  }
-	else
-	  {
-	    /* Use that point to split this problem into two subproblems.  */
-	    compareseq (xoff, b, yoff, b - d);
-	    /* This used to use f instead of b,
-	       but that is incorrect!
-	       It is not necessarily the case that diagonal d
-	       has a snake from b to f.  */
-	    compareseq (b, xlim, b - d, ylim);
-	  }
-      }
-  }
+	/**
+	 * Scan the tables of which lines are inserted and deleted, producing an edit
+	 * script in reverse order.
+	 */
 
-  /** Discard lines from one file that have no matches in the other file.
-   */
+	static class ReverseScript implements ScriptBuilder {
+		public change build_script(final boolean[] changed0, int len0, final boolean[] changed1, int len1) {
+			change script = null;
+			int i0 = 0, i1 = 0;
+			while (i0 < len0 || i1 < len1) {
+				if (changed0[1 + i0] || changed1[1 + i1]) {
+					int line0 = i0, line1 = i1;
 
-  private void discard_confusing_lines() {
-    filevec[0].discard_confusing_lines(filevec[1]);
-    filevec[1].discard_confusing_lines(filevec[0]);
-  }
+					/* Find # lines changed here in each file. */
+					while (changed0[1 + i0])
+						++i0;
+					while (changed1[1 + i1])
+						++i1;
 
-  private boolean inhibit = false;
+					/* Record this change. */
+					script = new change(line0, line1, i0 - line0, i1 - line1, script);
+				}
 
-  /** Adjust inserts/deletes of blank lines to join changes
-     as much as possible.
-   */
+				/* We have reached lines in the two files that match each other. */
+				i0++;
+				i1++;
+			}
 
-  private void shift_boundaries() {
-    if (inhibit)
-      return;
-    filevec[0].shift_boundaries(filevec[1]);
-    filevec[1].shift_boundaries(filevec[0]);
-  }
+			return script;
+		}
+	}
 
-  public interface ScriptBuilder {
-  /** Scan the tables of which lines are inserted and deleted,
-     producing an edit script. 
-   @param changed0 true for lines in first file which do not match 2nd
-   @param len0 number of lines in first file
-   @param changed1 true for lines in 2nd file which do not match 1st
-   @param len1 number of lines in 2nd file
-   @return a linked list of changes - or null
-   */
-    public change build_script(
-      boolean[] changed0,int len0,
-      boolean[] changed1,int len1
-    );
-  }
+	static class ForwardScript implements ScriptBuilder {
+		/**
+		 * Scan the tables of which lines are inserted and deleted, producing an edit
+		 * script in forward order.
+		 */
+		public change build_script(final boolean[] changed0, int len0, final boolean[] changed1, int len1) {
+			change script = null;
+			int i0 = len0, i1 = len1;
 
-  /** Scan the tables of which lines are inserted and deleted,
-     producing an edit script in reverse order.  */
+			while (i0 >= 0 || i1 >= 0) {
+				if (changed0[i0] || changed1[i1]) {
+					int line0 = i0, line1 = i1;
 
-  static class ReverseScript implements ScriptBuilder {
-    public  change build_script(
-	final boolean[] changed0,int len0,
-	final boolean[] changed1,int len1)
-    {
-      change script = null;
-      int i0 = 0, i1 = 0;
-      while (i0 < len0 || i1 < len1) {
-	if (changed0[1+i0] || changed1[1+i1]) {
-	    int line0 = i0, line1 = i1;
+					/* Find # lines changed here in each file. */
+					while (changed0[i0])
+						--i0;
+					while (changed1[i1])
+						--i1;
 
-	    /* Find # lines changed here in each file.  */
-	    while (changed0[1+i0]) ++i0;
-	    while (changed1[1+i1]) ++i1;
+					/* Record this change. */
+					script = new change(i0, i1, line0 - i0, line1 - i1, script);
+				}
 
-	    /* Record this change.  */
-	    script = new change(line0, line1, i0 - line0, i1 - line1, script);
+				/* We have reached lines in the two files that match each other. */
+				i0--;
+				i1--;
+			}
+
+			return script;
+		}
 	}
 
-	/* We have reached lines in the two files that match each other.  */
-	i0++; i1++;
-      }
+	/** Standard ScriptBuilders. */
+	public final static ScriptBuilder forwardScript = new ForwardScript(), reverseScript = new ReverseScript();
 
-      return script;
-    }
-  }
+	/*
+	 * Report the differences of two files. DEPTH is the current directory depth.
+	 */
+	public final change diff_2(final boolean reverse) {
+		return diff(reverse ? reverseScript : forwardScript);
+	}
 
-  static class ForwardScript implements ScriptBuilder {
-    /** Scan the tables of which lines are inserted and deleted,
-       producing an edit script in forward order.  */
-    public change build_script(
-	  final boolean[] changed0,int len0,
-	  final boolean[] changed1,int len1)
-    {
-      change script = null;
-      int i0 = len0, i1 = len1;
+	/**
+	 * Get the results of comparison as an edit script. The script is described by a
+	 * list of changes. The standard ScriptBuilder implementations provide for
+	 * forward and reverse edit scripts. Alternate implementations could, for
+	 * instance, list common elements instead of differences.
+	 * 
+	 * @param bld
+	 *            an object to build the script from change flags
+	 * @return the head of a list of changes
+	 */
+	public change diff(final ScriptBuilder bld) {
 
-      while (i0 >= 0 || i1 >= 0)
-	{
-	  if (changed0[i0] || changed1[i1])
-	    {
-	      int line0 = i0, line1 = i1;
+		/*
+		 * Some lines are obviously insertions or deletions because they don't match
+		 * anything. Detect them now, and avoid even thinking about them in the main
+		 * comparison algorithm.
+		 */
 
-	      /* Find # lines changed here in each file.  */
-	      while (changed0[i0]) --i0;
-	      while (changed1[i1]) --i1;
+		discard_confusing_lines();
 
-	      /* Record this change.  */
-	      script = new change(i0, i1, line0 - i0, line1 - i1, script);
-	    }
+		/*
+		 * Now do the main comparison algorithm, considering just the undiscarded lines.
+		 */
 
-	  /* We have reached lines in the two files that match each other.  */
-	  i0--; i1--;
-	}
+		xvec = filevec[0].undiscarded;
+		yvec = filevec[1].undiscarded;
 
-      return script;
-    }
-  }
+		int diags = filevec[0].nondiscarded_lines + filevec[1].nondiscarded_lines + 3;
+		fdiag = new int[diags];
+		fdiagoff = filevec[1].nondiscarded_lines + 1;
+		bdiag = new int[diags];
+		bdiagoff = filevec[1].nondiscarded_lines + 1;
 
-  /** Standard ScriptBuilders. */
-  public final static ScriptBuilder
-    forwardScript = new ForwardScript(),
-    reverseScript = new ReverseScript();
+		compareseq(0, filevec[0].nondiscarded_lines, 0, filevec[1].nondiscarded_lines);
+		fdiag = null;
+		bdiag = null;
 
-  /* Report the differences of two files.  DEPTH is the current directory
-     depth. */
-  public final change diff_2(final boolean reverse) {
-    return diff(reverse ? reverseScript : forwardScript);
-  }
+		/*
+		 * Modify the results slightly to make them prettier in cases where that can
+		 * validly be done.
+		 */
 
-  /** Get the results of comparison as an edit script.  The script 
-     is described by a list of changes.  The standard ScriptBuilder
-     implementations provide for forward and reverse edit scripts.
-     Alternate implementations could, for instance, list common elements 
-     instead of differences.
-     @param bld	an object to build the script from change flags
-     @return the head of a list of changes
-   */
-  public change diff(final ScriptBuilder bld) {
+		shift_boundaries();
 
-    /* Some lines are obviously insertions or deletions
-       because they don't match anything.  Detect them now,
-       and avoid even thinking about them in the main comparison algorithm.  */
+		/*
+		 * Get the results of comparison in the form of a chain of `struct change's --
+		 * an edit script.
+		 */
+		return bld.build_script(filevec[0].changed_flag, filevec[0].buffered_lines, filevec[1].changed_flag, filevec[1].buffered_lines);
 
-    discard_confusing_lines ();
+	}
 
-    /* Now do the main comparison algorithm, considering just the
-       undiscarded lines.  */
+	/**
+	 * The result of comparison is an "edit script": a chain of change objects. Each
+	 * change represents one place where some lines are deleted and some are
+	 * inserted.
+	 * 
+	 * LINE0 and LINE1 are the first affected lines in the two files (origin 0).
+	 * DELETED is the number of lines deleted here from file 0. INSERTED is the
+	 * number of lines inserted here in file 1.
+	 * 
+	 * If DELETED is 0 then LINE0 is the number of the line before which the
+	 * insertion was done; vice versa for INSERTED and LINE1.
+	 */
 
-    xvec = filevec[0].undiscarded;
-    yvec = filevec[1].undiscarded;
+	public static class change {
+		/** Previous or next edit command. */
+		public change link;
+		/** # lines of file 1 changed here. */
+		public final int inserted;
+		/** # lines of file 0 changed here. */
+		public final int deleted;
+		/** Line number of 1st deleted line. */
+		public final int line0;
+		/** Line number of 1st inserted line. */
+		public final int line1;
 
-    int diags =
-      filevec[0].nondiscarded_lines + filevec[1].nondiscarded_lines + 3;
-    fdiag = new int[diags];
-    fdiagoff = filevec[1].nondiscarded_lines + 1;
-    bdiag = new int[diags];
-    bdiagoff = filevec[1].nondiscarded_lines + 1;
+		/**
+		 * Cons an additional entry onto the front of an edit script OLD. LINE0 and
+		 * LINE1 are the first affected lines in the two files (origin 0). DELETED is
+		 * the number of lines deleted here from file 0. INSERTED is the number of lines
+		 * inserted here in file 1.
+		 * 
+		 * If DELETED is 0 then LINE0 is the number of the line before which the
+		 * insertion was done; vice versa for INSERTED and LINE1.
+		 */
+		public change(int line0, int line1, int deleted, int inserted, change old) {
+			this.line0 = line0;
+			this.line1 = line1;
+			this.inserted = inserted;
+			this.deleted = deleted;
+			this.link = old;
+			// System.err.println(line0+","+line1+","+inserted+","+deleted);
+		}
+	}
 
-    compareseq (0, filevec[0].nondiscarded_lines,
-		0, filevec[1].nondiscarded_lines);
-    fdiag = null;
-    bdiag = null;
+	/**
+	 * Data on one input file being compared.
+	 */
 
-    /* Modify the results slightly to make them prettier
-       in cases where that can validly be done.  */
+	class file_data {
 
-    shift_boundaries ();
+		/** Allocate changed array for the results of comparison. */
+		void clear() {
+			/*
+			 * Allocate a flag for each line of each file, saying whether that line is an
+			 * insertion or deletion. Allocate an extra element, always zero, at each end of
+			 * each vector.
+			 */
+			changed_flag = new boolean[buffered_lines + 2];
+		}
 
-    /* Get the results of comparison in the form of a chain
-       of `struct change's -- an edit script.  */
-    return bld.build_script(
-      filevec[0].changed_flag,
-      filevec[0].buffered_lines,
-      filevec[1].changed_flag,
-      filevec[1].buffered_lines
-    );
+		/**
+		 * Return equiv_count[I] as the number of lines in this file that fall in
+		 * equivalence class I.
+		 * 
+		 * @return the array of equivalence class counts.
+		 */
+		int[] equivCount() {
+			int[] equiv_count = new int[equiv_max];
+			for (int i = 0; i < buffered_lines; ++i)
+				++equiv_count[equivs[i]];
+			return equiv_count;
+		}
 
-  }
+		/**
+		 * Discard lines that have no matches in another file.
+		 * 
+		 * A line which is discarded will not be considered by the actual comparison
+		 * algorithm; it will be as if that line were not in the file. The file's
+		 * `realindexes' table maps virtual line numbers (which don't count the
+		 * discarded lines) into real line numbers; this is how the actual comparison
+		 * algorithm produces results that are comprehensible when the discarded lines
+		 * are counted.
+		 * <p>
+		 * When we discard a line, we also mark it as a deletion or insertion so that it
+		 * will be printed in the output.
+		 * 
+		 * @param f
+		 *            the other file
+		 */
+		void discard_confusing_lines(file_data f) {
+			clear();
+			/* Set up table of which lines are going to be discarded. */
+			final byte[] discarded = discardable(f.equivCount());
 
-  /** The result of comparison is an "edit script": a chain of change objects.
-     Each change represents one place where some lines are deleted
-     and some are inserted.
-     
-     LINE0 and LINE1 are the first affected lines in the two files (origin 0).
-     DELETED is the number of lines deleted here from file 0.
-     INSERTED is the number of lines inserted here in file 1.
+			/*
+			 * Don't really discard the provisional lines except when they occur in a run of
+			 * discardables, with nonprovisionals at the beginning and end.
+			 */
+			filterDiscards(discarded);
 
-     If DELETED is 0 then LINE0 is the number of the line before
-     which the insertion was done; vice versa for INSERTED and LINE1.  */
+			/* Actually discard the lines. */
+			discard(discarded);
+		}
 
-  public static class change {
-    /** Previous or next edit command. */
-    public change link;		
-    /** # lines of file 1 changed here.  */
-    public final int inserted;	
-    /** # lines of file 0 changed here.  */
-    public final int deleted;		
-    /** Line number of 1st deleted line.  */
-    public final int line0;		
-    /** Line number of 1st inserted line.  */
-    public final int line1;		
+		/**
+		 * Mark to be discarded each line that matches no line of another file. If a
+		 * line matches many lines, mark it as provisionally discardable.
+		 * 
+		 * @see equivCount()
+		 * @param counts
+		 *            The count of each equivalence number for the other file.
+		 * @return 0=nondiscardable, 1=discardable or 2=provisionally discardable for
+		 *         each line
+		 */
 
-    /** Cons an additional entry onto the front of an edit script OLD.
-       LINE0 and LINE1 are the first affected lines in the two files (origin 0).
-       DELETED is the number of lines deleted here from file 0.
-       INSERTED is the number of lines inserted here in file 1.
+		private byte[] discardable(final int[] counts) {
+			final int end = buffered_lines;
+			final byte[] discards = new byte[end];
+			final int[] equivs = this.equivs;
+			int many = 5;
+			int tem = end / 64;
 
-       If DELETED is 0 then LINE0 is the number of the line before
-       which the insertion was done; vice versa for INSERTED and LINE1.  */
-    public change(int line0, int line1, int deleted, int inserted, change old) {
-      this.line0 = line0;
-      this.line1 = line1;
-      this.inserted = inserted;
-      this.deleted = deleted;
-      this.link = old;
-      //System.err.println(line0+","+line1+","+inserted+","+deleted);
-    }
-  }
+			/*
+			 * Multiply MANY by approximate square root of number of lines. That is the
+			 * threshold for provisionally discardable lines.
+			 */
+			while ((tem = tem >> 2) > 0)
+				many *= 2;
 
-  /** Data on one input file being compared.  
-   */
+			for (int i = 0; i < end; i++) {
+				int nmatch;
+				if (equivs[i] == 0)
+					continue;
+				nmatch = counts[equivs[i]];
+				if (nmatch == 0)
+					discards[i] = 1;
+				else if (nmatch > many)
+					discards[i] = 2;
+			}
+			return discards;
+		}
 
-  class file_data {
+		/**
+		 * Don't really discard the provisional lines except when they occur in a run of
+		 * discardables, with nonprovisionals at the beginning and end.
+		 */
 
-    /** Allocate changed array for the results of comparison.  */
-    void clear() {
-      /* Allocate a flag for each line of each file, saying whether that line
-	 is an insertion or deletion.
-	 Allocate an extra element, always zero, at each end of each vector.
-       */
-      changed_flag = new boolean[buffered_lines + 2];
-    }
+		private void filterDiscards(final byte[] discards) {
+			final int end = buffered_lines;
 
-    /** Return equiv_count[I] as the number of lines in this file
-       that fall in equivalence class I.
-         @return the array of equivalence class counts.
-     */
-    int[] equivCount() {
-      int[] equiv_count = new int[equiv_max];
-      for (int i = 0; i < buffered_lines; ++i)
-	++equiv_count[equivs[i]];
-      return equiv_count;
-    }
+			for (int i = 0; i < end; i++) {
+				/* Cancel provisional discards not in middle of run of discards. */
+				if (discards[i] == 2)
+					discards[i] = 0;
+				else if (discards[i] != 0) {
+					/* We have found a nonprovisional discard. */
+					int j;
+					int length;
+					int provisional = 0;
 
-    /** Discard lines that have no matches in another file.
+					/*
+					 * Find end of this run of discardable lines. Count how many are provisionally
+					 * discardable.
+					 */
+					for (j = i; j < end; j++) {
+						if (discards[j] == 0)
+							break;
+						if (discards[j] == 2)
+							++provisional;
+					}
 
-       A line which is discarded will not be considered by the actual
-       comparison algorithm; it will be as if that line were not in the file.
-       The file's `realindexes' table maps virtual line numbers
-       (which don't count the discarded lines) into real line numbers;
-       this is how the actual comparison algorithm produces results
-       that are comprehensible when the discarded lines are counted.
-<p>
-       When we discard a line, we also mark it as a deletion or insertion
-       so that it will be printed in the output.  
-      @param f the other file   
-     */
-    void discard_confusing_lines(file_data f) {
-      clear();
-    /* Set up table of which lines are going to be discarded. */
-      final byte[] discarded = discardable(f.equivCount());
+					/* Cancel provisional discards at end, and shrink the run. */
+					while (j > i && discards[j - 1] == 2) {
+						discards[--j] = 0;
+						--provisional;
+					}
 
-    /* Don't really discard the provisional lines except when they occur
-       in a run of discardables, with nonprovisionals at the beginning
-       and end.  */
-      filterDiscards(discarded);
+					/*
+					 * Now we have the length of a run of discardable lines whose first and last are
+					 * not provisional.
+					 */
+					length = j - i;
 
-    /* Actually discard the lines. */
-      discard(discarded);
-    }
+					/*
+					 * If 1/4 of the lines in the run are provisional, cancel discarding of all
+					 * provisional lines in the run.
+					 */
+					if (provisional * 4 > length) {
+						while (j > i)
+							if (discards[--j] == 2)
+								discards[j] = 0;
+					} else {
+						int consec;
+						int minimum = 1;
+						int tem = length / 4;
 
-    /** Mark to be discarded each line that matches no line of another file.
-       If a line matches many lines, mark it as provisionally discardable.  
-       @see equivCount()
-       @param counts The count of each equivalence number for the other file.
-       @return 0=nondiscardable, 1=discardable or 2=provisionally discardable
-       	for each line
-     */
+						/*
+						 * MINIMUM is approximate square root of LENGTH/4. A subrun of two or more
+						 * provisionals can stand when LENGTH is at least 16. A subrun of 4 or more can
+						 * stand when LENGTH >= 64.
+						 */
+						while ((tem = tem >> 2) > 0)
+							minimum *= 2;
+						minimum++;
 
-    private byte[] discardable(final int[] counts) {
-      final int end = buffered_lines;
-      final byte[] discards = new byte[end];
-      final int[] equivs = this.equivs;
-      int many = 5;
-      int tem = end / 64;
+						/*
+						 * Cancel any subrun of MINIMUM or more provisionals within the larger run.
+						 */
+						for (j = 0, consec = 0; j < length; j++)
+							if (discards[i + j] != 2)
+								consec = 0;
+							else if (minimum == ++consec)
+								/* Back up to start of subrun, to cancel it all. */
+								j -= consec;
+							else if (minimum < consec)
+								discards[i + j] = 0;
 
-      /* Multiply MANY by approximate square root of number of lines.
-	 That is the threshold for provisionally discardable lines.  */
-      while ((tem = tem >> 2) > 0)
-	many *= 2;
+						/*
+						 * Scan from beginning of run until we find 3 or more nonprovisionals in a row
+						 * or until the first nonprovisional at least 8 lines in. Until that point,
+						 * cancel any provisionals.
+						 */
+						for (j = 0, consec = 0; j < length; j++) {
+							if (j >= 8 && discards[i + j] == 1)
+								break;
+							if (discards[i + j] == 2) {
+								consec = 0;
+								discards[i + j] = 0;
+							} else if (discards[i + j] == 0)
+								consec = 0;
+							else
+								consec++;
+							if (consec == 3)
+								break;
+						}
 
-      for (int i = 0; i < end; i++)
-	{
-	  int nmatch;
-	  if (equivs[i] == 0)
-	    continue;
-	  nmatch = counts[equivs[i]];
-	  if (nmatch == 0)
-	    discards[i] = 1;
-	  else if (nmatch > many)
-	    discards[i] = 2;
-	}
-      return discards;
-    }
+						/* I advances to the last line of the run. */
+						i += length - 1;
 
-    /** Don't really discard the provisional lines except when they occur
-       in a run of discardables, with nonprovisionals at the beginning
-       and end.  */
+						/* Same thing, from end. */
+						for (j = 0, consec = 0; j < length; j++) {
+							if (j >= 8 && discards[i - j] == 1)
+								break;
+							if (discards[i - j] == 2) {
+								consec = 0;
+								discards[i - j] = 0;
+							} else if (discards[i - j] == 0)
+								consec = 0;
+							else
+								consec++;
+							if (consec == 3)
+								break;
+						}
+					}
+				}
+			}
+		}
 
-    private void filterDiscards(final byte[] discards) {
-	final int end = buffered_lines;
+		/**
+		 * Actually discard the lines.
+		 * 
+		 * @param discards
+		 *            flags lines to be discarded
+		 */
+		private void discard(final byte[] discards) {
+			final int end = buffered_lines;
+			int j = 0;
+			for (int i = 0; i < end; ++i)
+				if (no_discards || discards[i] == 0) {
+					undiscarded[j] = equivs[i];
+					realindexes[j++] = i;
+				} else
+					changed_flag[1 + i] = true;
+			nondiscarded_lines = j;
+		}
 
-	for (int i = 0; i < end; i++)
-	  {
-	    /* Cancel provisional discards not in middle of run of discards.  */
-	    if (discards[i] == 2)
-	      discards[i] = 0;
-	    else if (discards[i] != 0)
-	      {
-		/* We have found a nonprovisional discard.  */
-		int j;
-		int length;
-		int provisional = 0;
+		file_data(Object[] data, Hashtable h) {
+			buffered_lines = data.length;
 
-		/* Find end of this run of discardable lines.
-		   Count how many are provisionally discardable.  */
-		for (j = i; j < end; j++)
-		  {
-		    if (discards[j] == 0)
-		      break;
-		    if (discards[j] == 2)
-		      ++provisional;
-		  }
+			equivs = new int[buffered_lines];
+			undiscarded = new int[buffered_lines];
+			realindexes = new int[buffered_lines];
 
-		/* Cancel provisional discards at end, and shrink the run.  */
-		while (j > i && discards[j - 1] == 2) {
-		  discards[--j] = 0; --provisional;
+			for (int i = 0; i < data.length; ++i) {
+				Integer ir = (Integer) h.get(data[i]);
+				if (ir == null)
+					h.put(data[i], new Integer(equivs[i] = equiv_max++));
+				else
+					equivs[i] = ir.intValue();
+			}
 		}
 
-		/* Now we have the length of a run of discardable lines
-		   whose first and last are not provisional.  */
-		length = j - i;
+		/**
+		 * Adjust inserts/deletes of blank lines to join changes as much as possible.
+		 * 
+		 * We do something when a run of changed lines include a blank line at one end
+		 * and have an excluded blank line at the other. We are free to choose which
+		 * blank line is included. `compareseq' always chooses the one at the beginning,
+		 * but usually it is cleaner to consider the following blank line to be the
+		 * "change". The only exception is if the preceding blank line would join this
+		 * change to other changes.
+		 * 
+		 * @param f
+		 *            the file being compared against
+		 */
 
-		/* If 1/4 of the lines in the run are provisional,
-		   cancel discarding of all provisional lines in the run.  */
-		if (provisional * 4 > length)
-		  {
-		    while (j > i)
-		      if (discards[--j] == 2)
-			discards[j] = 0;
-		  }
-		else
-		  {
-		    int consec;
-		    int minimum = 1;
-		    int tem = length / 4;
+		void shift_boundaries(file_data f) {
+			final boolean[] changed = changed_flag;
+			final boolean[] other_changed = f.changed_flag;
+			int i = 0;
+			int j = 0;
+			int i_end = buffered_lines;
+			int preceding = -1;
+			int other_preceding = -1;
 
-		    /* MINIMUM is approximate square root of LENGTH/4.
-		       A subrun of two or more provisionals can stand
-		       when LENGTH is at least 16.
-		       A subrun of 4 or more can stand when LENGTH >= 64.  */
-		    while ((tem = tem >> 2) > 0)
-		      minimum *= 2;
-		    minimum++;
+			for (;;) {
+				int start, end, other_start;
 
-		    /* Cancel any subrun of MINIMUM or more provisionals
-		       within the larger run.  */
-		    for (j = 0, consec = 0; j < length; j++)
-		      if (discards[i + j] != 2)
-			consec = 0;
-		      else if (minimum == ++consec)
-			/* Back up to start of subrun, to cancel it all.  */
-			j -= consec;
-		      else if (minimum < consec)
-			discards[i + j] = 0;
+				/*
+				 * Scan forwards to find beginning of another run of changes. Also keep track of
+				 * the corresponding point in the other file.
+				 */
 
-		    /* Scan from beginning of run
-		       until we find 3 or more nonprovisionals in a row
-		       or until the first nonprovisional at least 8 lines in.
-		       Until that point, cancel any provisionals.  */
-		    for (j = 0, consec = 0; j < length; j++)
-		      {
-			if (j >= 8 && discards[i + j] == 1)
-			  break;
-			if (discards[i + j] == 2) {
-			  consec = 0; discards[i + j] = 0;
-			}
-			else if (discards[i + j] == 0)
-			  consec = 0;
-			else
-			  consec++;
-			if (consec == 3)
-			  break;
-		      }
+				while (i < i_end && !changed[1 + i]) {
+					while (other_changed[1 + j++])
+						/*
+						 * Non-corresponding lines in the other file will count as the preceding batch
+						 * of changes.
+						 */
+						other_preceding = j;
+					i++;
+				}
 
-		    /* I advances to the last line of the run.  */
-		    i += length - 1;
+				if (i == i_end)
+					break;
 
-		    /* Same thing, from end.  */
-		    for (j = 0, consec = 0; j < length; j++)
-		      {
-			if (j >= 8 && discards[i - j] == 1)
-			  break;
-			if (discards[i - j] == 2) {
-			  consec = 0; discards[i - j] = 0;
-			}
-			else if (discards[i - j] == 0)
-			  consec = 0;
-			else
-			  consec++;
-			if (consec == 3)
-			  break;
-		      }
-		  }
-	      }
-	  }
-      }
+				start = i;
+				other_start = j;
 
-    /** Actually discard the lines.
-      @param discards flags lines to be discarded
-     */
-    private void discard(final byte[] discards) {
-      final int end = buffered_lines;
-      int j = 0;
-      for (int i = 0; i < end; ++i)
-	if (no_discards || discards[i] == 0)
-	  {
-	    undiscarded[j] = equivs[i];
-	    realindexes[j++] = i;
-	  }
-	else
-	  changed_flag[1+i] = true;
-      nondiscarded_lines = j;
-    }
+				for (;;) {
+					/* Now find the end of this run of changes. */
 
-    file_data(Object[] data,Hashtable h) {
-      buffered_lines = data.length;
+					while (i < i_end && changed[1 + i])
+						i++;
+					end = i;
 
-      equivs = new int[buffered_lines]; 
-      undiscarded = new int[buffered_lines];
-      realindexes = new int[buffered_lines];
+					/*
+					 * If the first changed line matches the following unchanged one, and this run
+					 * does not follow right after a previous run, and there are no lines deleted
+					 * from the other file here, then classify the first changed line as unchanged
+					 * and the following line as changed in its place.
+					 */
 
-      for (int i = 0; i < data.length; ++i) {
-        Integer ir = (Integer)h.get(data[i]);
-	if (ir == null)
-	  h.put(data[i],new Integer(equivs[i] = equiv_max++));
-	else
-	  equivs[i] = ir.intValue();
-      }
-    }
+					/*
+					 * You might ask, how could this run follow right after another? Only because
+					 * the previous run was shifted here.
+					 */
 
-    /** Adjust inserts/deletes of blank lines to join changes
-       as much as possible.
+					if (end != i_end && equivs[start] == equivs[end] && !other_changed[1 + j] && end != i_end && !((preceding >= 0 && start == preceding) || (other_preceding >= 0 && other_start == other_preceding))) {
+						changed[1 + end++] = true;
+						changed[1 + start++] = false;
+						++i;
+						/*
+						 * Since one line-that-matches is now before this run instead of after, we must
+						 * advance in the other file to keep in synch.
+						 */
+						++j;
+					} else
+						break;
+				}
 
-       We do something when a run of changed lines include a blank
-       line at one end and have an excluded blank line at the other.
-       We are free to choose which blank line is included.
-       `compareseq' always chooses the one at the beginning,
-       but usually it is cleaner to consider the following blank line
-       to be the "change".  The only exception is if the preceding blank line
-       would join this change to other changes.  
-      @param f the file being compared against
-    */
+				preceding = i;
+				other_preceding = j;
+			}
+		}
 
-    void shift_boundaries(file_data f) {
-      final boolean[] changed = changed_flag;
-      final boolean[] other_changed = f.changed_flag;
-      int i = 0;
-      int j = 0;
-      int i_end = buffered_lines;
-      int preceding = -1;
-      int other_preceding = -1;
+		/** Number of elements (lines) in this file. */
+		final int buffered_lines;
 
-      for (;;)
-	{
-	  int start, end, other_start;
+		/**
+		 * Vector, indexed by line number, containing an equivalence code for each line.
+		 * It is this vector that is actually compared with that of another file to
+		 * generate differences.
+		 */
+		private final int[] equivs;
 
-	  /* Scan forwards to find beginning of another run of changes.
-	     Also keep track of the corresponding point in the other file.  */
+		/**
+		 * Vector, like the previous one except that the elements for discarded lines
+		 * have been squeezed out.
+		 */
+		final int[] undiscarded;
 
-	  while (i < i_end && !changed[1+i])
-	    {
-	      while (other_changed[1+j++])
-		/* Non-corresponding lines in the other file
-		   will count as the preceding batch of changes.  */
-		other_preceding = j;
-	      i++;
-	    }
+		/**
+		 * Vector mapping virtual line numbers (not counting discarded lines) to real
+		 * ones (counting those lines). Both are origin-0.
+		 */
+		final int[] realindexes;
 
-	  if (i == i_end)
-	    break;
+		/** Total number of nondiscarded lines. */
+		int nondiscarded_lines;
 
-	  start = i;
-	  other_start = j;
+		/**
+		 * Array, indexed by real origin-1 line number, containing true for a line that
+		 * is an insertion or a deletion. The results of comparison are stored here.
+		 */
+		boolean[] changed_flag;
 
-	  for (;;)
-	    {
-	      /* Now find the end of this run of changes.  */
+	}
 
-	      while (i < i_end && changed[1+i]) i++;
-	      end = i;
+	public static Object[] getLines(File file) throws IOException {
+		ArrayList<String> lines = new ArrayList<String>();
+		BufferedReader in = new BufferedReader(new FileReader(file));
+		String line = in.readLine();
+		while (line != null) {
+			lines.add(line);
+			line = in.readLine();
+		}
+		in.close();
+		return lines.toArray();
+	}
 
-	      /* If the first changed line matches the following unchanged one,
-		 and this run does not follow right after a previous run,
-		 and there are no lines deleted from the other file here,
-		 then classify the first changed line as unchanged
-		 and the following line as changed in its place.  */
+	public static String diffFile(File file1, File file2) throws IOException {
+		if (file1.exists() && file2.exists()) {
 
-	      /* You might ask, how could this run follow right after another?
-		 Only because the previous run was shifted here.  */
+			Object[] test1 = getLines(file1);
+			Object[] test2 = getLines(file2);
 
-	      if (end != i_end
-		  && equivs[start] == equivs[end]
-		  && !other_changed[1+j]
-		  && end != i_end
-		  && !((preceding >= 0 && start == preceding)
-		       || (other_preceding >= 0
-			   && other_start == other_preceding)))
-		{
-		  changed[1+end++] = true;
-		  changed[1+start++] = false;
-		  ++i;
-		  /* Since one line-that-matches is now before this run
-		     instead of after, we must advance in the other file
-		     to keep in synch.  */
-		  ++j;
+			Diff diff = new Diff(test1, test2);
+			Diff.change script = diff.diff_2(false);
+			DiffPrint.Base p = new DiffPrint.UnifiedPrint(test1, test2);
+			StringWriter wtr = new StringWriter();
+			p.setOutput(wtr);
+			p.print_script(script);
+			// System.out.println(wtr.toString());
+			return wtr.toString().trim();
 		}
-	      else
-		break;
-	    }
-
-	  preceding = i;
-	  other_preceding = j;
+		return ""; //$NON-NLS-1$
 	}
-    }
 
-    /** Number of elements (lines) in this file. */
-    final int buffered_lines;
+	public static String diffFolder(File dir1, File dir2) throws IOException {
+		if (dir1.exists() && dir2.exists()) {
 
-    /** Vector, indexed by line number, containing an equivalence code for
-       each line.  It is this vector that is actually compared with that
-       of another file to generate differences. */
-    private final int[]	    equivs;
+		}
+		return ""; //$NON-NLS-1$
+	}
 
-    /** Vector, like the previous one except that
-       the elements for discarded lines have been squeezed out.  */
-    final int[]	   undiscarded;
+	public static void main(String args[]) {
+		// String[] test1 = {
+		// "aaa","bbb","ccc","ddd","eee","fff","ggg","hhh","iii"
+		// };
+		// String[] test2 = {
+		// "aaa","bbb","ccc","ddd","eee","fff","ggg","hhh","iii"
+		// };
+		//
+		// Diff diff = new Diff(test1,test2);
+		// Diff.change script = diff.diff_2(false);
+		// DiffPrint.Base p = new DiffPrint.UnifiedPrint(test1,test2);
+		// StringWriter wtr = new StringWriter();
+		// p.setOutput(wtr);
+		// p.print_script(script);
+		// System.out.println(wtr.toString());
 
-    /** Vector mapping virtual line numbers (not counting discarded lines)
-       to real ones (counting those lines).  Both are origin-0.  */
-    final int[]	   realindexes;
-
-    /** Total number of nondiscarded lines. */
-    int		    nondiscarded_lines;
-
-    /** Array, indexed by real origin-1 line number,
-       containing true for a line that is an insertion or a deletion.
-       The results of comparison are stored here.  */
-    boolean[]	    changed_flag;
-
-  }
-  
-  public static Object[] getLines(File file) throws IOException {
-	  ArrayList<String> lines = new ArrayList<String>();
-	  BufferedReader in = new BufferedReader(new FileReader(file));
-	  String line = in.readLine();
-	  while (line != null) {
-		  lines.add(line);
-		  line = in.readLine();
-	  }
-	  in.close();
-	  return lines.toArray();
-  }
-  
-  public static String diffFile(File file1, File file2) throws IOException {
-	  if (file1.exists() && file2.exists()) {
-		  
-		  Object[] test1 = getLines(file1);
-		  Object[] test2 = getLines(file2);
-		  
-		  Diff diff = new Diff(test1,test2);
-		    Diff.change script = diff.diff_2(false);
-		    DiffPrint.Base p = new DiffPrint.UnifiedPrint(test1,test2);
-		    StringWriter wtr = new StringWriter();
-		    p.setOutput(wtr);
-		    p.print_script(script);
-		    //System.out.println(wtr.toString());
-		    return wtr.toString().trim();
-	  }
-	  return ""; //$NON-NLS-1$
-  }
-  
-  public static String diffFolder(File dir1, File dir2) throws IOException {
-	  if (dir1.exists() && dir2.exists()) {
-		  
-	  }
-	  return ""; //$NON-NLS-1$
-  }
-  
-  public static void main(String args[]) {
-//	 String[] test1 = {
-//		    "aaa","bbb","ccc","ddd","eee","fff","ggg","hhh","iii"
-//		  };
-//	 String[] test2 = {
-//			 "aaa","bbb","ccc","ddd","eee","fff","ggg","hhh","iii"
-//		  };
-//	  
-//	 Diff diff = new Diff(test1,test2);
-//	    Diff.change script = diff.diff_2(false);
-//	    DiffPrint.Base p = new DiffPrint.UnifiedPrint(test1,test2);
-//	    StringWriter wtr = new StringWriter();
-//	    p.setOutput(wtr);
-//	    p.print_script(script);
-//	    System.out.println(wtr.toString());
-	  
-	  File file1 = new File("/home/mdecorde/paquets/shared/debian/usr/lib/TXM/install.prefs"); //$NON-NLS-1$
-	  File file2 = new File("/home/mdecorde/paquets/shared/win/install.prefs"); //$NON-NLS-1$
-	  try {
-		System.out.println(diffFile(file1, file2));
-	} catch (IOException e) {
-		// TODO Auto-generated catch block
-		org.txm.utils.logger.Log.printStackTrace(e);
+		File file1 = new File("/home/mdecorde/paquets/shared/debian/usr/lib/TXM/install.prefs"); //$NON-NLS-1$
+		File file2 = new File("/home/mdecorde/paquets/shared/win/install.prefs"); //$NON-NLS-1$
+		try {
+			System.out.println(diffFile(file1, file2));
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			org.txm.utils.logger.Log.printStackTrace(e);
+		}
 	}
-  }
 }
